in scala.io
object BytePickle

`object` BytePickle
  `extends` java.lang.Object
  `with` scala.ScalaObject

  Pickler combinators. Based on a Haskell library by Andrew Kennedy, see http://research.microsoft.com/~akenn/fun/.

Author:
  Philipp Haller (philipp.haller<at>epfl.ch)
Version:
  1.0

Class Summary
`case` | `class` Def
`abstract` | `class` PU [t]
| `class` PicklerEnv
| `class` PicklerState
`case` | `class` Ref
`abstract` | `class` RefDef
`abstract` | `class` SPU [t]
| `class` UnPicklerEnv
| `class` UnPicklerState

Constructor Summary
| `def` this

Val Summary
| `val` DEF : scala.Int
| `val` REF : scala.Int

Def Summary
| `def` appendByte (a: scala.Array[scala.Byte], b: scala.Int) : scala.Array[scala.Byte]
| `def` bool : scala.io.BytePickle.SPU[scala.Boolean]
| `def` byte : scala.io.BytePickle.SPU[scala.Byte]
| `def` bytearray : scala.io.BytePickle.SPU[scala.Array[scala.Byte]]
| `def` data [a] (tag: scala.Function1[a, scala.Int], ps: scala.List[scala.Function0[scala.io.BytePickle.SPU[a]]]) : scala.io.BytePickle.SPU[a]
| `def` fixedList [a] (pa: scala.io.BytePickle.SPU[a])(n: scala.Int) : scala.io.BytePickle.SPU[scala.List[a]]
| `def` lift [t] (x: t) : scala.io.BytePickle.SPU[t]
| `def` list [a] (pa: scala.io.BytePickle.SPU[a]) : scala.io.BytePickle.SPU[scala.List[a]]
| `def` nat : scala.io.BytePickle.SPU[scala.Int]
| `def` nat2Bytes (x: scala.Int) : scala.Array[scala.Byte]
| `def` pair [a, b] (pa: scala.io.BytePickle.SPU[a], pb: scala.io.BytePickle.SPU[b]) : scala.io.BytePickle.SPU[scala.Tuple2[a, b]]
| `def` pickle [t] (p: scala.io.BytePickle.SPU[t], a: t) : scala.Array[scala.Byte]
| `def` refDef : scala.io.BytePickle.PU[BytePickle.this.RefDef]
| `def` sequ [t, u] (f: scala.Function1[u, t], pa: scala.io.BytePickle.SPU[t], k: scala.Function1[t, scala.io.BytePickle.SPU[u]]) : scala.io.BytePickle.SPU[u]
| `def` share [a] (pa: scala.io.BytePickle.SPU[a]) : scala.io.BytePickle.SPU[a]
| `def` string : scala.io.BytePickle.SPU[java.lang.String]
| `def` triple [a, b, c] (pa: scala.io.BytePickle.SPU[a], pb: scala.io.BytePickle.SPU[b], pc: scala.io.BytePickle.SPU[c]) : scala.io.BytePickle.SPU[scala.Tuple3[a, b, c]]
| `def` ufixedList [a] (pa: scala.io.BytePickle.PU[a])(n: scala.Int) : scala.io.BytePickle.PU[scala.List[a]]
| `def` ulift [t] (x: t) : scala.io.BytePickle.PU[t]
| `def` ulist [a] (pa: scala.io.BytePickle.PU[a]) : scala.io.BytePickle.PU[scala.List[a]]
| `def` unat : scala.io.BytePickle.PU[scala.Int]
| `def` unpickle [t] (p: scala.io.BytePickle.SPU[t], stream: scala.Array[scala.Byte]) : t
| `def` upair [a, b] (pa: scala.io.BytePickle.PU[a], pb: scala.io.BytePickle.PU[b]) : scala.io.BytePickle.PU[scala.Tuple2[a, b]]
| `def` upickle [t] (p: scala.io.BytePickle.PU[t], a: t) : scala.Array[scala.Byte]
| `def` usequ [t, u] (f: scala.Function1[u, t], pa: scala.io.BytePickle.PU[t], k: scala.Function1[t, scala.io.BytePickle.PU[u]]) : scala.io.BytePickle.PU[u]
| `def` uunpickle [t] (p: scala.io.BytePickle.PU[t], stream: scala.Array[scala.Byte]) : t
| `def` uwrap [a, b] (i: scala.Function1[a, b], j: scala.Function1[b, a], pa: scala.io.BytePickle.PU[a]) : scala.io.BytePickle.PU[b]
| `def` wrap [a, b] (i: scala.Function1[a, b], j: scala.Function1[b, a], pa: scala.io.BytePickle.SPU[a]) : scala.io.BytePickle.SPU[b]

Constructor Detail

`def` this

Val Detail

`val` DEF : scala.Int

`val` REF : scala.Int

Def Detail

`def` appendByte (a: scala.Array[scala.Byte], b: scala.Int): scala.Array[scala.Byte]

`def` bool : scala.io.BytePickle.SPU[scala.Boolean]

`def` byte : scala.io.BytePickle.SPU[scala.Byte]

`def` bytearray : scala.io.BytePickle.SPU[scala.Array[scala.Byte]]

`def` data [a](tag: scala.Function1[a, scala.Int], ps: scala.List[scala.Function0[scala.io.BytePickle.SPU[a]]]): scala.io.BytePickle.SPU[a]

`def` fixedList [a](pa: scala.io.BytePickle.SPU[a])(n: scala.Int): scala.io.BytePickle.SPU[scala.List[a]]

`def` lift [t](x: t): scala.io.BytePickle.SPU[t]

`def` list [a](pa: scala.io.BytePickle.SPU[a]): scala.io.BytePickle.SPU[scala.List[a]]

`def` nat : scala.io.BytePickle.SPU[scala.Int]

`def` nat2Bytes (x: scala.Int): scala.Array[scala.Byte]

`def` pair [a, b](pa: scala.io.BytePickle.SPU[a], pb: scala.io.BytePickle.SPU[b]): scala.io.BytePickle.SPU[scala.Tuple2[a, b]]

`def` pickle [t](p: scala.io.BytePickle.SPU[t], a: t): scala.Array[scala.Byte]

`def` refDef : scala.io.BytePickle.PU[BytePickle.this.RefDef]

`def` sequ [t, u](f: scala.Function1[u, t], pa: scala.io.BytePickle.SPU[t], k: scala.Function1[t, scala.io.BytePickle.SPU[u]]): scala.io.BytePickle.SPU[u]

`def` share [a](pa: scala.io.BytePickle.SPU[a]): scala.io.BytePickle.SPU[a]

`def` string : scala.io.BytePickle.SPU[java.lang.String]

`def` triple [a, b, c](pa: scala.io.BytePickle.SPU[a], pb: scala.io.BytePickle.SPU[b], pc: scala.io.BytePickle.SPU[c]): scala.io.BytePickle.SPU[scala.Tuple3[a, b, c]]

`def` ufixedList [a](pa: scala.io.BytePickle.PU[a])(n: scala.Int): scala.io.BytePickle.PU[scala.List[a]]

`def` ulift [t](x: t): scala.io.BytePickle.PU[t]

`def` ulist [a](pa: scala.io.BytePickle.PU[a]): scala.io.BytePickle.PU[scala.List[a]]

`def` unat : scala.io.BytePickle.PU[scala.Int]

`def` unpickle [t](p: scala.io.BytePickle.SPU[t], stream: scala.Array[scala.Byte]): t

`def` upair [a, b](pa: scala.io.BytePickle.PU[a], pb: scala.io.BytePickle.PU[b]): scala.io.BytePickle.PU[scala.Tuple2[a, b]]

`def` upickle [t](p: scala.io.BytePickle.PU[t], a: t): scala.Array[scala.Byte]

`def` usequ [t, u](f: scala.Function1[u, t], pa: scala.io.BytePickle.PU[t], k: scala.Function1[t, scala.io.BytePickle.PU[u]]): scala.io.BytePickle.PU[u]

`def` uunpickle [t](p: scala.io.BytePickle.PU[t], stream: scala.Array[scala.Byte]): t

`def` uwrap [a, b](i: scala.Function1[a, b], j: scala.Function1[b, a], pa: scala.io.BytePickle.PU[a]): scala.io.BytePickle.PU[b]

`def` wrap [a, b](i: scala.Function1[a, b], j: scala.Function1[b, a], pa: scala.io.BytePickle.SPU[a]): scala.io.BytePickle.SPU[b]